import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// Here we show the construction of bisecting a given angle.
// This is done in analogy to the classical euclidean geometry.

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

// The four points A, B, C, D given
hyperbolic_point A = hyperbolic_point(1.8,80);
hyperbolic_point B = hyperbolic_point(2.2,300);
hyperbolic_point C = hyperbolic_point(1.1,30);
hyperbolic_point D = hyperbolic_point(2.5,250);

// The two lines going through {A,B} and {C,D}
hyperbolic_line g = hyperbolic_line(A,B);
hyperbolic_line h = hyperbolic_line(C,D);

// The intersection of these lines
hyperbolic_point I = intersection(g,h);

// Construct equidistant point on both lines
hyperbolic_circle c = hyperbolic_circle(I,A);
hyperbolic_point[] K = intersection(c,g);
hyperbolic_point[] L = intersection(c,h);

// Construct the intersecting circles
hyperbolic_circle c1 = hyperbolic_circle(K[0], I);
hyperbolic_circle c2 = hyperbolic_circle(L[0], I);

// The intersection of the two circles
hyperbolic_point[] M = intersection(c1, c2);

// Constrcut the bisecting line
hyperbolic_line W = hyperbolic_line(M[0], M[1]);

// And draw all the stuff
draw(g, blue);
draw(h, blue);

draw(c, gray);
draw(c1, gray);
draw(c2, gray);
draw(W, orange);

dot(K[0], gray);
dot(L[0], gray);
dot(A, black);
dot(B, black);
dot(C, black);
dot(D, black);
dot(I, orange);
dot(M, orange);


draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
